﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using MeshVR.Hands;

namespace MVRPlugin {
	public class Template : MVRScript {

		// IMPORTANT - DO NOT make custom enums. The dynamic C# complier crashes Unity when it encounters these for
		// some reason
		private static Atom person;
        private static FreeControllerV3 lShoulderController;
        private static FreeControllerV3 rShoulderController;
        private static FreeControllerV3 lArmController;
        private static FreeControllerV3 rArmController;
        private static FreeControllerV3 lHandController;
        private static FreeControllerV3 rHandController;
        private static FreeControllerV3 abdomenController;
        private static FreeControllerV3 pelvisController;
        private static FreeControllerV3 chestController;
        private static FreeControllerV3 lNippleController;
        private static FreeControllerV3 rNippleController;
        private static FreeControllerV3 neckController;
        private static FreeControllerV3 headController;
        private static FreeControllerV3 lHipController;
        private static FreeControllerV3 rHipController;
        private static FreeControllerV3 lFootController;
        private static FreeControllerV3 rFootController;
        private static FreeControllerV3 lToeController;
        private static FreeControllerV3 rToeController;
		
		protected JSONStorableBool uianimatehands;
		protected JSONStorableBool uigenericcol;
		protected JSONStorableFloat uimotionspeed;
		protected JSONStorableFloat uianimationspeed;
		protected JSONStorableFloat uidistancescale;
		protected JSONStorableFloat uiposeadjust;
		protected JSONStorableFloat uithumbadjust;
		protected JSONStorableFloat uigraspadjust;
		protected JSONStorableFloat uistraightenadjust;
		protected JSONStorableFloat uichopadjust;
		protected JSONStorableFloat uithumboffset;
		protected JSONStorableFloat uifingercurl;
		protected JSONStorableFloat uitoeground;
		protected JSONStorableFloat uitoegroundclear;
		protected JSONStorableBool uiShowStats;
		
		
        private static DAZMorph morphLHandFist;
        private static float mLHandFistValue = 0.0f;
        private static float mLHandFistTarget = 0.0f;
        private static DAZMorph morphRHandFist;
        private static float mRHandFistValue = 0.0f;
        private static float mRHandFistTarget = 0.0f;

        private static DAZMorph morphLThumbGrasp;
        private static DAZMorph morphRThumbGrasp;
        private static DAZMorph morphLThumbFist;
        private static DAZMorph morphRThumbFist;
        private static DAZMorph morphLThumbInOut;
        private static DAZMorph morphRThumbInOut;
        private static DAZMorph morphLHandChop;

        private static DAZMorph morphLPinkyBend;
        private static DAZMorph morphRPinkyBend;
        private static DAZMorph morphLRingBend;
        private static DAZMorph morphRRingBend;
        private static DAZMorph morphLMiddleBend;
        private static DAZMorph morphRMiddleBend;
        private static DAZMorph morphLIndexBend;
        private static DAZMorph morphRIndexBend;
        private static Atom aCube;
		private static FreeControllerV3 aCubeController;


        private static float mLHandChopValue = 0.0f;
        private static float mLHandChopTarget = 0.0f;
        private static DAZMorph morphRHandChop;
        private static float mRHandChopValue = 0.0f;
        private static float mRHandChopTarget = 0.0f;
        private static DAZMorph morphLHandStraighten;
        private static float mLHandStraightenValue = 0.0f;
        private static float mLHandStraightenTarget = 0.0f;
        private static DAZMorph morphRHandStraighten;
        private static float mRHandStraightenValue = 0.0f;
        private static float mRHandStraightenTarget = 0.0f;
		private static float lHandCollisionTimer = 0.0f;
		private static float rHandCollisionTimer = 0.0f;
		private static float toeAmount = 0.0f;
		
		private static float rthumbOutActual = 0.0f;
		private static float lthumbOutActual = 0.0f;
		private static float lhandcurlActual = 0.0f;
		private static float rhandcurlActual = 0.0f;
		//private static float LThumbBendManual = 0.0f;
		
		
		private static float lHandRelaxAmount = 0.0f;
		private static float lHandRelaxAmountActual = 0.0f;
		private static float rHandRelaxAmount = 0.0f;
		private static float rHandRelaxAmountActual = 0.0f;
		private static float lHandRelaxActual = 0.0f;
		private static float rHandRelaxActual = 0.0f;
		
		private static string lhanddebugold = "";
		private static string rhanddebugold = "";
		private static string lhanddebug = "";
		private static string rhanddebug = "";

		private static float morphBufferL = 0.1f;
		private static float poseSwitchCountL = 0.0f;
		private static float morphBufferR = 0.1f;
		private static float poseSwitchCountR = 0.0f;
		
		protected Vector3 lhandpos;
		protected Vector3 rhandpos;
		protected Vector3 lcurhandpos;
		protected Vector3 rcurhandpos;
		
		private static DAZMorph[] morphFingersFist;
		private static float[] morphFingersFistValue;
		private static DAZMorph[] morphFingersInOut;
		private static float[] morphFingersInOutValue;
		private static DAZMorph[] morphFingerIndexBend;
		private static float[] morphFingerIndexBendValue;
		private static DAZMorph[] morphFingerMidBend;
		private static float[] morphFingerMidBendValue;
		private static DAZMorph[] morphFingerPinkyBend;
		private static float[] morphFingerPinkyBendValue;
		private static DAZMorph[] morphFingerRingBend;
		private static float[] morphFingerRingBendValue;
		private static DAZMorph[] morphThumbBend;
		private static float[] morphThumbBendValue;
		private static DAZMorph[] morphThumbFist;
		private static float[] morphThumbFistValue;
		private static DAZMorph[] morphThumbGrasp;
		private static float[] morphThumbGraspValue;
		private static DAZMorph[] morphThumbInOut;
		private static float[] morphThumbInOutValue;
		private static DAZMorph[] morphThumbStraighten;
		private static float[] morphThumbStraightenValue;
		
		private static Vector3[] handPosition;
		private static Vector3[] handLastPosition;
		private static string[] fingerPoseNameArray; 
		private static float[,,] fingerPoseArray; 
		private static float[,] fingerMorphArray;
		private static float[,,] fingerInputArray;
		private static float[] fingerMorphDamper;
		private static float[] fingerMorphThumbDelay;
		private static int[][] fingerPoseOverrides;		
		private static string[] handState;

		private static int[] currentMatch;
		private static float[] currentMatchTime;
		private static int totalPoses;
		private static int currentMatchL;
		private static int currentMatchR;
		private static float currentMatchLTime;
		private static float currentMatchRTime;
		private static bool morphsReset;
		//Added by Timbo
		private static JSONStorable jsp;

		protected JSONStorableFloat uiMinFingers;
		protected JSONStorableFloat uiFingerAccuracy;
		protected JSONStorableFloat uiHoldTime;
		protected JSONStorableFloat uiAnimationSpeed;
		protected JSONStorableBool uiSkipDistal;
		protected JSONStorableBool uiNoMatchRelax;
		protected JSONStorableStringChooser uiDefaultPose;
		// IMPORTANT - DO NOT OVERRIDE Awake() as it is used internally by MVRScript - instead use Init() function which
		// is called right after creation
		public override void Init() {
			try {
				// put init code in here
				
				//Start Timbo
				//	jsp = containingAtom.GetStorableByID("PosePresets");
				//	JSONStorableUrl presetPathJSON = jsp.GetUrlJSONParam("presetBrowsePath");
				//	if(presetPathJSON!=null){presetPathJSON.val = SuperController.singleton.NormalizePath("./Custom/Atom/Person/Pose/Preset_Fingers Reset.vap");}
				//	jsp.CallAction("LoadPreset");
				//End Timbo				
				
				SuperController.LogMessage("Hand Animator Loaded");
				morphFingersFist = new DAZMorph[2];
				morphFingersFistValue = new float[2];
				morphFingersInOut = new DAZMorph[2];
				morphFingersInOutValue = new float[2];
				morphFingerIndexBend = new DAZMorph[2];
				morphFingerIndexBendValue = new float[2];
				morphFingerMidBend = new DAZMorph[2];
				morphFingerMidBendValue = new float[2];
				morphFingerPinkyBend = new DAZMorph[2];
				morphFingerPinkyBendValue = new float[2];
				morphFingerRingBend = new DAZMorph[2];
				morphFingerRingBendValue = new float[2];
				morphThumbBend = new DAZMorph[2];
				morphThumbBendValue = new float[2];
				morphThumbFist = new DAZMorph[2];
				morphThumbFistValue = new float[2];
				morphThumbGrasp = new DAZMorph[2];
				morphThumbGraspValue = new float[2];
				morphThumbInOut = new DAZMorph[2];
				morphThumbInOutValue = new float[2];
				morphThumbStraighten = new DAZMorph[2];
				morphThumbStraightenValue = new float[2];	
				

				
				person = containingAtom;
                headController = person.GetStorableByID("headControl") as FreeControllerV3;
                neckController = person.GetStorableByID("neckControl") as FreeControllerV3;
                chestController = person.GetStorableByID("chestControl") as FreeControllerV3;
                lNippleController = person.GetStorableByID("lNippleControl") as FreeControllerV3;
                rNippleController = person.GetStorableByID("rNippleControl") as FreeControllerV3;
                abdomenController = person.GetStorableByID("abdomen2Control") as FreeControllerV3;
                pelvisController = person.GetStorableByID("pelvisControl") as FreeControllerV3;
                lShoulderController = person.GetStorableByID("lShoulderControl") as FreeControllerV3;
                rShoulderController = person.GetStorableByID("rShoulderControl") as FreeControllerV3;
                lArmController = person.GetStorableByID("lArmControl") as FreeControllerV3;
                rArmController = person.GetStorableByID("rArmControl") as FreeControllerV3;
                lHandController = person.GetStorableByID("lHandControl") as FreeControllerV3;
                rHandController = person.GetStorableByID("rHandControl") as FreeControllerV3;
                lHipController = person.GetStorableByID("lThighControl") as FreeControllerV3;
                rHipController = person.GetStorableByID("rThighControl") as FreeControllerV3;
                lFootController = person.GetStorableByID("lFootControl") as FreeControllerV3;
                rFootController = person.GetStorableByID("rFootControl") as FreeControllerV3;
                lToeController = person.GetStorableByID("lToeControl") as FreeControllerV3;
                rToeController = person.GetStorableByID("rToeControl") as FreeControllerV3;
				
				lhandpos = lcurhandpos;
				rhandpos = rHandController.followWhenOff.position;
				
                JSONStorable js = person.GetStorableByID("geometry");
                DAZCharacterSelector dcs = js as DAZCharacterSelector;
                GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
				morphLHandFist = morphUI.GetMorphByDisplayName("Left Hand Grasp");
				morphRHandFist = morphUI.GetMorphByDisplayName("Right Hand Grasp");
				morphLThumbGrasp = morphUI.GetMorphByDisplayName("Left Thumb Bend");
				morphRThumbGrasp = morphUI.GetMorphByDisplayName("Right Thumb Bend");
				morphLThumbFist = morphUI.GetMorphByDisplayName("Left Thumb Fist");
				morphRThumbFist = morphUI.GetMorphByDisplayName("Right Thumb Fist");
				morphLThumbInOut = morphUI.GetMorphByDisplayName("Left Thumb In-Out");
				morphRThumbInOut = morphUI.GetMorphByDisplayName("Right Thumb In-Out");
				morphLHandChop = morphUI.GetMorphByDisplayName("Left Hand Chop");
				morphRHandChop = morphUI.GetMorphByDisplayName("Right Hand Chop");
				morphLHandStraighten = morphUI.GetMorphByDisplayName("Left Hand Straighten");
				morphRHandStraighten = morphUI.GetMorphByDisplayName("Right Hand Straighten");

				morphLPinkyBend = morphUI.GetMorphByDisplayName("Left Pinky Finger Bend");
				morphRPinkyBend = morphUI.GetMorphByDisplayName("Right Pinky Finger Bend");
				morphLRingBend = morphUI.GetMorphByDisplayName("Left Ring Finger Bend");
				morphRRingBend = morphUI.GetMorphByDisplayName("Right Ring Finger Bend");
				morphLMiddleBend = morphUI.GetMorphByDisplayName("Left Mid Finger Bend");
				morphRMiddleBend = morphUI.GetMorphByDisplayName("Right Mid Finger Bend");
				morphLIndexBend = morphUI.GetMorphByDisplayName("Left Index Finger Bend");
				morphRIndexBend = morphUI.GetMorphByDisplayName("Right Index Finger Bend");

				handPosition = new Vector3[2];
				handPosition[0] = lHandController.followWhenOff.position;
				handPosition[1] = rHandController.followWhenOff.position;

				handLastPosition = new Vector3[2];
				handLastPosition[0] = handPosition[0];
				handLastPosition[1] = handPosition[1];
				
				handState = new string[2];
				handState[0] = "Init";
				handState[1] = "Init";

				totalPoses = 3;
				fingerPoseNameArray = new string[totalPoses];
				fingerPoseArray = new float[totalPoses, 5, 3];
				fingerMorphArray = new float[totalPoses, 6];
				fingerInputArray = new float[2, 5, 3];
				fingerMorphDamper = new float[totalPoses];
				fingerMorphThumbDelay = new float[totalPoses];
				fingerPoseOverrides = new int[totalPoses][];
				currentMatch = new int[2];
				currentMatchTime = new float[2];

				fingerPoseNameArray[0] = "Open Relaxed";
				fingerPoseArray[0,0,0] = 10.0f; //Pinky
				fingerPoseArray[0,0,1] = 10.0f;
				fingerPoseArray[0,0,2] = 10.0f;
				fingerPoseArray[0,1,0] = 10.0f; //Ring
				fingerPoseArray[0,1,1] = 10.0f;
				fingerPoseArray[0,1,2] = 10.0f;
				fingerPoseArray[0,2,0] = 10.0f; //Middle
				fingerPoseArray[0,2,1] = 10.0f;
				fingerPoseArray[0,2,2] = 10.0f;
				fingerPoseArray[0,3,0] = 10.0f; //Index
				fingerPoseArray[0,3,1] = 10.0f;
				fingerPoseArray[0,3,2] = 10.0f;
				fingerPoseArray[0,4,0] = 10.0f; //Thumb
				fingerPoseArray[0,4,1] = 10.0f;
				fingerPoseArray[0,4,2] = 10.0f;
				
				fingerMorphArray[0,0] = 0.5f; //Straighten
				fingerMorphArray[0,1] = 0.0f; //Fist
				fingerMorphArray[0,2] = 0.0f; //Chop
				fingerMorphArray[0,3] = 0.2f; //Curl
				fingerMorphArray[0,4] = 0.5f; //Relax
				fingerMorphArray[0,5] = 0.0f; //Thumb Out

				
				fingerMorphDamper[0] = 0.85f; //Finger Damper (pinky slowest <1.0f)
				fingerMorphThumbDelay[0] = 0.0f; //Thumb Delay (-1:Thumb First, +1FingersFirst)
				fingerPoseOverrides[0] = new int[] { -1 }; //store override array with pose.
														   //each value is the index of the pose that cannot be overriden. -1 for no override
				
				fingerPoseNameArray[1] = "Relaxed Fist";
				fingerPoseArray[1,0,0] = 30.0f; //Pinky
				fingerPoseArray[1,0,1] = 30.0f;
				fingerPoseArray[1,0,2] = 30.0f;
				fingerPoseArray[1,1,0] = 30.0f; //Ring
				fingerPoseArray[1,1,1] = 30.0f;
				fingerPoseArray[1,1,2] = 30.0f;
				fingerPoseArray[1,2,0] = 30.0f; //Middle
				fingerPoseArray[1,2,1] = 30.0f;
				fingerPoseArray[1,2,2] = 30.0f;
				fingerPoseArray[1,3,0] = 30.0f; //Index
				fingerPoseArray[1,3,1] = 30.0f;
				fingerPoseArray[1,3,2] = 30.0f;
				fingerPoseArray[1,4,0] = 30.0f; //Thumb
				fingerPoseArray[1,4,1] = 30.0f;
				fingerPoseArray[1,4,2] = 30.0f;

				fingerMorphArray[1,0] = 0.0f; //Straighten
				fingerMorphArray[1,1] = 0.8f; //Fist
				fingerMorphArray[1,2] = 0.2f; //Chop
				fingerMorphArray[1,3] = 0.0f; //Curl
				fingerMorphArray[1,4] = 0.0f; //Relax
				fingerMorphArray[1,5] = 0.0f; //Thumb Out


				fingerMorphDamper[1] = 0.0f; //Finger Damper (pinky slowest <1.0f)
				fingerMorphThumbDelay[1] = -0.1f; //Thumb Delay (-1:Thumb First, +1FingersFirst)
				fingerPoseOverrides[1] = new int[] { -1 }; //store override array with pose.
														   //each value is the index of the pose that cannot be overriden. -1 for no override

				fingerPoseNameArray[2] = "Pointing Finger";
				fingerPoseArray[2,0,0] = 30.0f; //Pinky
				fingerPoseArray[2,0,1] = 30.0f;
				fingerPoseArray[2,0,2] = 30.0f;
				fingerPoseArray[2,1,0] = 30.0f; //Ring
				fingerPoseArray[2,1,1] = 30.0f;
				fingerPoseArray[2,1,2] = 30.0f;
				fingerPoseArray[2,2,0] = 30.0f; //Middle
				fingerPoseArray[2,2,1] = 30.0f;
				fingerPoseArray[2,2,2] = 30.0f;
				fingerPoseArray[2,3,0] = 10.0f; //Index
				fingerPoseArray[2,3,1] = 10.0f;
				fingerPoseArray[2,3,2] = 10.0f;
				fingerPoseArray[2,4,0] = 30.0f; //Thumb
				fingerPoseArray[2,4,1] = 30.0f;
				fingerPoseArray[2,4,2] = 30.0f;
				
				fingerMorphArray[2,0] = 0.15f; //Straighten
				fingerMorphArray[2,1] = 0.0f; //Fist
				fingerMorphArray[2,2] = 0.2f; //Chop
				fingerMorphArray[2,3] = 0.8f; //Curl
				fingerMorphArray[2,4] = 0.2f; //Relax
				fingerMorphArray[2,5] = 0.0f; //Thumb Out

				
				fingerMorphDamper[2] = 0.8f; //Finger Damper (pinky slowest <1.0f)
				fingerMorphThumbDelay[2] = 0.6f; //Thumb Delay (-1:Thumb First, +1FingersFirst)
				fingerPoseOverrides[2] = new int[] { -1 }; //store override array with pose.
														   //each value is the index of the pose that cannot be overriden. -1 for no override
					
				currentMatchL = -1;
				currentMatchR = -1;
				currentMatchLTime = 0.0f;
				currentMatchRTime = 0.0f;
				
				currentMatch[0] = -1;
				currentMatch[1] = -1;
				currentMatchTime[0] = 0.0f;
				currentMatchTime[1] = 0.0f;

			
			uianimatehands = new JSONStorableBool("Dynamically Adjust Hand Morphs", true);
			RegisterBool(uianimatehands);
			CreateToggle(uianimatehands, true);
			uigenericcol = new JSONStorableBool("flatten on any surface (buggy)", false);
			RegisterBool(uigenericcol);
			CreateToggle(uigenericcol, true);
			uiShowStats = new JSONStorableBool("Show stats on message log", false);
			RegisterBool(uiShowStats);
			CreateToggle(uiShowStats, true);
			uiposeadjust = new JSONStorableFloat("Static Pose Modifier", 0.4f, 0.0f, 2.0f, true, true);
			RegisterFloat(uiposeadjust);
			CreateSlider(uiposeadjust, true);
			uigraspadjust = new JSONStorableFloat("Grasp Morph Modifier", 1.0f, 0.0f, 2.0f, true, true);
			RegisterFloat(uigraspadjust);
			CreateSlider(uigraspadjust, true);
			uistraightenadjust = new JSONStorableFloat("Straighten Morph Modifier", 1.5f, 0.0f, 2.0f, true, true);
			RegisterFloat(uistraightenadjust);
			CreateSlider(uistraightenadjust, true);
			uichopadjust = new JSONStorableFloat("Chop Morph Modifier", 0.5f, -2.0f, 2.0f, true, true);
			RegisterFloat(uichopadjust);
			CreateSlider(uichopadjust, true);
			uithumbadjust = new JSONStorableFloat("Thumbs Morphs Modifier", 0.3f, 0.0f, 2.0f, true, true);
			RegisterFloat(uithumbadjust);
			CreateSlider(uithumbadjust, true);
			uithumboffset = new JSONStorableFloat("Thumbs Position Offset", 0.17f, -1.0f, 1.0f, true, true);
			RegisterFloat(uithumboffset);
			CreateSlider(uithumboffset, true);
			uimotionspeed = new JSONStorableFloat("Motion Speed Scale", 1.0f, 0.0f, 5.0f, true, true);
			RegisterFloat(uimotionspeed);
			CreateSlider(uimotionspeed, false);
			uidistancescale = new JSONStorableFloat("Distance Scale", 1.06f, 0.0f, 5.0f, true, true);
			RegisterFloat(uidistancescale);
			CreateSlider(uidistancescale, false);
			uianimationspeed = new JSONStorableFloat("Animation Speed", 2.0f, 0.0f, 5.0f, true, true);
			RegisterFloat(uianimationspeed);
			CreateSlider(uianimationspeed, false);
			uifingercurl = new JSONStorableFloat("Relaxed finger curl", 0.44f, -1.0f, 2.0f, true, true);
			RegisterFloat(uifingercurl);
			CreateSlider(uifingercurl, false);

			uitoeground = new JSONStorableFloat("Ground Level", 0.0f, -5.0f, 5.0f, true, true);
			RegisterFloat(uitoeground);
			CreateSlider(uitoeground, false);
			uitoegroundclear = new JSONStorableFloat("Ground Clearance", 0.1f, -5.0f, 5.0f, true, true);
			RegisterFloat(uitoegroundclear);
			CreateSlider(uitoegroundclear, false);

				uiFingerAccuracy = new JSONStorableFloat("Finger Position Accuracy", 5.0f, 0.0f, 35.0f, true, true);
				RegisterFloat(uiFingerAccuracy);
				CreateSlider(uiFingerAccuracy, false);

				uiHoldTime = new JSONStorableFloat("Hold Time for Pose Switch", 0.5f, 0.0f, 5.0f, true, true);
				RegisterFloat(uiHoldTime);
				CreateSlider(uiHoldTime, false);

				uiMinFingers = new JSONStorableFloat("Minimum Fingers To Match", 4.0f, 0.0f, 5.0f, true, true);
				RegisterFloat(uiMinFingers);
				CreateSlider(uiMinFingers, true);

				uiSkipDistal = new JSONStorableBool("Skip Distal Joints", false);
				RegisterBool(uiSkipDistal);
				CreateToggle(uiSkipDistal, true);

            //aCube = SuperController.singleton.GetAtomByUid("Cube");
			//if (aCube != null)
			//{
			//aCubeController = aCube.GetStorableByID("control") as FreeControllerV3;
			//}
				// create custom JSON storable params here if you want them to be stored with scene JSON
				// types are JSONStorableFloat, JSONStorableBool, JSONStorableString, JSONStorableStringChooser
				// JSONStorableColor

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}


		// FixedUpdate is called with each physics simulation frame by Unity
		void Update() {
			try {
				// put code in here
				fingerInputArray[0,0,0] = HandInput.leftPinkyProximalBend;
				fingerInputArray[0,0,1] = HandInput.leftPinkyMiddleBend;
				fingerInputArray[0,0,2] = HandInput.leftPinkyDistalBend;
				fingerInputArray[0,1,0] = HandInput.leftRingProximalBend;
				fingerInputArray[0,1,1] = HandInput.leftRingMiddleBend;
				fingerInputArray[0,1,2] = HandInput.leftRingDistalBend;
				fingerInputArray[0,2,0] = HandInput.leftMiddleProximalBend;
				fingerInputArray[0,2,1] = HandInput.leftMiddleMiddleBend;
				fingerInputArray[0,2,2] = HandInput.leftMiddleDistalBend;
				fingerInputArray[0,3,0] = HandInput.leftIndexProximalBend;
				fingerInputArray[0,3,1] = HandInput.leftIndexMiddleBend;
				fingerInputArray[0,3,2] = HandInput.leftIndexDistalBend;
				fingerInputArray[0,4,0] = HandInput.leftThumbProximalBend;
				fingerInputArray[0,4,1] = HandInput.leftThumbMiddleBend;
				fingerInputArray[0,4,2] = HandInput.leftThumbDistalBend;

				fingerInputArray[1,0,0] = HandInput.rightPinkyProximalBend;
				fingerInputArray[1,0,1] = HandInput.rightPinkyMiddleBend;
				fingerInputArray[1,0,2] = HandInput.rightPinkyDistalBend;
				fingerInputArray[1,1,0] = HandInput.rightRingProximalBend;
				fingerInputArray[1,1,1] = HandInput.rightRingMiddleBend;
				fingerInputArray[1,1,2] = HandInput.rightRingDistalBend;
				fingerInputArray[1,2,0] = HandInput.rightMiddleProximalBend;
				fingerInputArray[1,2,1] = HandInput.rightMiddleMiddleBend;
				fingerInputArray[1,2,2] = HandInput.rightMiddleDistalBend;
				fingerInputArray[1,3,0] = HandInput.rightIndexProximalBend;
				fingerInputArray[1,3,1] = HandInput.rightIndexMiddleBend;
				fingerInputArray[1,3,2] = HandInput.rightIndexDistalBend;
				fingerInputArray[1,4,0] = HandInput.rightThumbProximalBend;
				fingerInputArray[1,4,1] = HandInput.rightThumbMiddleBend;
				fingerInputArray[1,4,2] = HandInput.rightThumbDistalBend;

				handPosition[0] = lHandController.followWhenOff.position;
				handPosition[1] = rHandController.followWhenOff.position;

				float handDist = Vector3.Distance(handPosition[0], handPosition[1]);

				float accuracy = uiFingerAccuracy.val;
				float minMatches = uiMinFingers.val;
				float minMatchTime = uiHoldTime.val;

				int matchedPose = -1;
				float fingerMatches = 0.0f;
				float currentMatches = 0.0f;
				int lastMatch = -1;

				
				float minHeadDist = 0.08f * uidistancescale.val;
				float minChestDist = 0.15f * uidistancescale.val;
				float minNippleDist = 0.1f  * uidistancescale.val;
				float minAbsDist = 0.10f * uidistancescale.val;
				float minHipDist = 0.15f * uidistancescale.val;
				float minHandDist = 0.14f * uidistancescale.val;
				float minThighDist = 0.16f * uidistancescale.val;
				float minPelvisDist = 0.05f * uidistancescale.val;
				float minMotion = 0.2f;
				float maxStraighten = 1.0f;
				float maxFist = 1.0f;
				float maxChop = 2.0f;

				if (uianimatehands.val)
				{
					lhanddebug = "Left Hand : ";
					rhanddebug = "Right Hand : ";
					RaycastHit hit;
					float hitDist = 0.0f;
					bool hitdetected = false;

					lcurhandpos = lHandController.followWhenOff.TransformPoint(new Vector3(-0.1f, 0.0f, 0.0f));
					rcurhandpos = rHandController.followWhenOff.TransformPoint(new Vector3(0.1f, 0.0f, 0.0f));
					float lhipLDist = Vector3.Distance(lcurhandpos, lHipController.followWhenOff.position);
					float lhipRDist = Vector3.Distance(lcurhandpos, rHipController.followWhenOff.position);
					float lthighLDist = Vector3.Distance(lcurhandpos, lHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
					float lthighRDist = Vector3.Distance(lcurhandpos, rHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
					float lpelvisDist = Vector3.Distance(lcurhandpos, pelvisController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
					float lchestDist = Vector3.Distance(lcurhandpos, chestController.followWhenOff.position);
					float lnippleLDist = Vector3.Distance(lcurhandpos, lNippleController.followWhenOff.position);
					float lnippleRDist = Vector3.Distance(lcurhandpos, rNippleController.followWhenOff.position);
					float labsDist = Vector3.Distance(lcurhandpos, abdomenController.followWhenOff.position);
					float lheadDist = Vector3.Distance(lcurhandpos, headController.followWhenOff.position);
					float lrhandDist = Vector3.Distance(lcurhandpos, rcurhandpos);
					float lmoveDist = Vector3.Distance(lcurhandpos, lhandpos) * uimotionspeed.val;
					float lfloorDist = Mathf.Max(lcurhandpos.y, uitoeground.val);
					float lhandCurl = 1.0f;
					float lthumbOut = 0.0f;
					lHandRelaxAmount = 1.0f;
					
					//aCubeController.transform.position = pelvisController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f));
					
					Vector3 lhanddir = chestController.followWhenOff.position - lcurhandpos;
					float ldotProduct = Vector3.Dot(lhanddir, chestController.followWhenOff.forward);
					
					if ((lchestDist > minChestDist && labsDist > minAbsDist && lheadDist > minHeadDist && lhipLDist > minHipDist && lhipRDist > minHipDist && lnippleLDist > minNippleDist && lnippleRDist > minNippleDist && lthighLDist > minThighDist && lthighRDist > minThighDist && lpelvisDist > minPelvisDist) || lmoveDist > minMotion)
					{
						if (lcurhandpos.y > neckController.followWhenOff.position.y)
						{
							if (lcurhandpos.y < headController.followWhenOff.position.y + 0.15f && lheadDist < 0.55f * uidistancescale.val)
							{
								mLHandStraightenTarget = 0.8f;
								mLHandFistTarget = maxFist * (Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
								mLHandChopValue = 2.0f;
								lhanddebug += " ParHead";
							}
							else
							{
								mLHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
								mLHandFistTarget = 0.0f;
								lhanddebug += " AboveHead";
							}
						}
						else
						{
							if (lmoveDist > 0.02f || (HandInput.leftIndexProximalBend > 28f))
							{
								mLHandStraightenTarget = maxStraighten;
								mLHandFistTarget = 0.0f;
								lhandCurl = 0.0f;
								lHandRelaxAmount = 0.0f;
								lhanddebug += " FastMove";
							}
							else
							{
								mLHandStraightenTarget = 0.0f;
								mLHandFistTarget = maxFist * 0.2f * uiposeadjust.val;
								lthumbOut = 0.15f;
								lhanddebug += " Slow";
							}
						}
						mLHandChopTarget = Mathf.Clamp(lmoveDist*33.0f, -0.2f, maxChop * 0.5f);
						
						if (lcurhandpos.y < lHipController.followWhenOff.position.y && lmoveDist > 0.02f)
						{
							mLHandStraightenTarget = maxStraighten;
							lhandCurl = 0.0f;
							mLHandChopTarget = -1.0f;
							lhanddebug += " Low";
						}
						
						if (lcurhandpos.y > chestController.followWhenOff.position.y && lmoveDist > 0.03f)
						{
							mLHandChopTarget = -0.5f;
							mLHandStraightenTarget = maxStraighten * 0.5f;
							mLHandFistTarget = 0.0f;
							lhanddebug += " ParChest";
						}
						if (lcurhandpos.y > chestController.followWhenOff.position.y && lcurhandpos.y < neckController.followWhenOff.position.y && lmoveDist < 0.0025f && lchestDist < 0.3f)
						{
							mLHandChopTarget = 0.0f;
							mLHandStraightenTarget = 0.0f;
							mLHandFistTarget = 0.7f * uiposeadjust.val;
							lhanddebug += " OnChest";
						}
						lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
						ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
						if (ldotProduct > 0.3f)
						{
							mLHandStraightenTarget = 0.0f;
							mLHandFistTarget = 0.8f;
							mLHandChopTarget = 0.0f;
							lhanddebug += " AtBack";
						}
						
						if (lrhandDist < minHandDist)
						{
							mLHandStraightenTarget = maxStraighten;
							mLHandFistTarget = 0.0f;
							mLHandChopTarget = -1.0f;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " Hands";
						}
						if (uigenericcol.val)
						{
							if (lHandController.followWhenOffRB.SweepTest(-lHandController.followWhenOff.up, out hit, 0.1f))
							{
								hitdetected = true;
								if (lmoveDist > 0.001f)
								{
									hitDist = Mathf.Min(hit.distance, 0.08f);
								}
								//SuperController.singleton.ClearErrors();
								//SuperController.LogError("Collision " + hit.distance);
							}
							if (hitdetected || lHandCollisionTimer > 0.0f)
							{
								if (lHandCollisionTimer <= 0.0f)
								{
									lHandCollisionTimer = 0.5f;
								}
								else
								{
									lHandCollisionTimer -= Time.fixedDeltaTime;
								}
								
								mLHandStraightenTarget = maxStraighten * 0.8f * (1.0f - (hitDist * 100.0f));
								mLHandFistTarget = maxFist * 0.1f;
								mLHandChopTarget = -0.2f;
								lhanddebug += " Col";
							}
						}
						if (lfloorDist < uitoeground.val + uitoegroundclear.val)
						{
							mLHandStraightenTarget = Mathf.Lerp(maxStraighten, 0.0f, lfloorDist/(uitoeground.val + uitoegroundclear.val));
							mLHandFistTarget = 0.0f;
							mLHandChopTarget = -0.2f;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " Floor";
						}
					}
					else
					{
						lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
						ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
						if (lhipLDist < minHipDist || lhipRDist < minHipDist)
						{
							if (ldotProduct > 0.1f)
							{
								mLHandStraightenTarget = 1.0f;
								mLHandFistTarget = 0.0f;
								mLHandChopTarget = 0.2f;
								lhanddebug += " AtButt";
							}
							else
							{
								mLHandStraightenTarget = maxStraighten * 0.6f;
								mLHandFistTarget = maxFist * 0.3f;
								mLHandChopTarget = -0.2f;
								lthumbOut = 0.2f;
								lhanddebug += " AtHip";
							}
						}
						if (labsDist < minAbsDist * 2.0f)
						{
							lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
							ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
							if (ldotProduct > 0.1f && labsDist < minAbsDist)
							{
								mLHandStraightenTarget = 0.0f;
								mLHandFistTarget = maxFist;
								mLHandChopTarget = 0.2f;
								lhanddebug += " BehindAbs";
							}
							else
							{
								if (ldotProduct < 0.5f)
								{
								mLHandStraightenTarget = maxStraighten * 0.6f;
								mLHandFistTarget = maxFist * 0.3f;
								mLHandChopTarget = -0.2f;
								lthumbOut = 0.5f;
									lhanddebug += " SideAbs";
								}
								else
								{
									if (labsDist < minAbsDist)
									{
										mLHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
										mLHandFistTarget = maxFist * 0.1f;
										mLHandChopTarget = 0.2f * uiposeadjust.val;
										lHandRelaxAmount = 0.5f;
										lhanddebug += " AtAbs";
									}
								}
							}
						}
						if (lthighLDist < minThighDist || lthighRDist < minThighDist)
						{
							mLHandStraightenTarget = maxStraighten * 1.5f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.0f;
							mLHandChopTarget = 0.0f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " atThigh";
						}
						if (lpelvisDist < minPelvisDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.0f;
							mLHandChopTarget = 0.8f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " Pelvis";
						}
						if (lchestDist < minChestDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.6f;
							mLHandFistTarget = maxFist * 0.3f;
							mLHandChopTarget = -0.5f;
							lhanddebug += " AtChest";
						}
						if (lnippleLDist < minNippleDist || lnippleRDist < minNippleDist)
						{
							mLHandStraightenTarget = 0.0f;
							mLHandStraightenTarget = maxStraighten * 0.8f;
							mLHandFistTarget = maxFist * 0.3f;
							mLHandChopTarget = 0.0f;
							lthumbOut = 0.20f;
							lhanddebug += " AtNipple";
						}
						lhanddir = headController.followWhenOff.position - lcurhandpos;
						ldotProduct = Vector3.Dot(lhanddir, headController.followWhenOff.forward);
						if (lheadDist < minHeadDist)
						{
							if (ldotProduct < -0.1f)
							{
								mLHandStraightenTarget = maxStraighten * 0.8f;
								mLHandFistTarget = maxFist * 0.1f;
								mLHandChopTarget = -0.7f;
								lHandRelaxAmount = 0.2f;
								lhanddebug += " AtFace";
							}
							else
							{
								if (ldotProduct > 0.07f)
								{
									mLHandStraightenTarget = maxStraighten * 0.4f;
									mLHandFistTarget = maxFist * 0.3f;
									mLHandChopTarget = -0.1f;
									lhanddebug += " BehindHead";
								}
								else
								{
									mLHandStraightenTarget = maxStraighten * 0.3f;
									mLHandFistTarget = maxFist * 0.1f;
									mLHandChopTarget = 0.3f;
									lhanddebug += " SideHead";
								}
							}
						}
					}
					
					float rhipLDist = Vector3.Distance(rcurhandpos, lHipController.followWhenOff.position);
					float rhipRDist = Vector3.Distance(rcurhandpos, rHipController.followWhenOff.position);
					float rthighLDist = Vector3.Distance(rcurhandpos, lHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
					float rthighRDist = Vector3.Distance(rcurhandpos, rHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
					float rpelvisDist = Vector3.Distance(rcurhandpos, pelvisController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
					float rchestDist = Vector3.Distance(rcurhandpos, chestController.followWhenOff.position);
					float rnippleLDist = Vector3.Distance(rcurhandpos, lNippleController.followWhenOff.position);
					float rnippleRDist = Vector3.Distance(rcurhandpos, rNippleController.followWhenOff.position);
					float rabsDist = Vector3.Distance(rcurhandpos, abdomenController.followWhenOff.position);
					float rheadDist = Vector3.Distance(rcurhandpos, headController.followWhenOff.position);
					float rlhandDist = Vector3.Distance(lcurhandpos, rcurhandpos);
					float rmoveDist = Vector3.Distance(rcurhandpos, rhandpos) * uimotionspeed.val;
					float rfloorDist = Mathf.Max(lcurhandpos.y, uitoeground.val);
					float rhandCurl = 1.0f;
					float rthumbOut = 0.0f;
					rHandRelaxAmount = 1.0f;
					hitdetected = false;
					
					Vector3 rhanddir = chestController.followWhenOff.position - rcurhandpos;
					float rdotProduct = Vector3.Dot(rhanddir, chestController.followWhenOff.forward);

					if ((rchestDist > minChestDist && rabsDist > minAbsDist && rheadDist > minHeadDist && rhipLDist > minHipDist && rhipRDist > minHipDist && rnippleLDist > minNippleDist && rnippleRDist > minNippleDist && rthighLDist > minThighDist && rthighRDist > minThighDist && rpelvisDist > minPelvisDist) || rmoveDist > minMotion)
					{
						if (rcurhandpos.y > neckController.followWhenOff.position.y)
						{
							if (rcurhandpos.y < headController.followWhenOff.position.y + 0.15f && rheadDist < 0.55f * uidistancescale.val)
							{
								mRHandStraightenTarget = 0.3f;
								mRHandFistTarget = maxFist * (Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
								mRHandChopValue = 2.0f;
								rhanddebug += " ParHead";
							}
							else
							{
								mRHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
								mRHandFistTarget = 0.0f;
								rhanddebug += " AboveHead";
							}
						}
						else
						{
							if (rmoveDist > 0.02f || (HandInput.rightIndexProximalBend > 28f))
							{
								mRHandStraightenTarget = maxStraighten;
								mRHandFistTarget = 0.0f;
								rhandCurl = 0.0f;
								rHandRelaxAmount = 0.0f;
								rhanddebug += " FastMove";
							}
							else
							{
								mRHandStraightenTarget = 0.0f;
								mRHandFistTarget = maxFist * 0.2f * uiposeadjust.val;
								rthumbOut = 0.15f;
								rhandCurl = 0.0f;
								rhanddebug += " Slow";
							}
						}
						mRHandChopTarget = Mathf.Clamp(rmoveDist*33.0f, -0.2f, maxChop * 0.5f);
						
						if (rcurhandpos.y < rHipController.followWhenOff.position.y && rmoveDist > 0.02f)
						{
							mRHandStraightenTarget = maxStraighten;
							mRHandChopTarget = -1.0f;
							rhandCurl = 0.0f;
							rhanddebug += " Low";
						}
						if (rcurhandpos.y > chestController.followWhenOff.position.y && rmoveDist > 0.03f)
						{
							mRHandChopTarget = -0.5f;
							mRHandStraightenTarget = maxStraighten * 0.5f;
							mRHandFistTarget = 0.0f;
							rhanddebug += " ParChest";
						}
						if (rcurhandpos.y > chestController.followWhenOff.position.y && rcurhandpos.y < neckController.followWhenOff.position.y && rmoveDist < 0.0025f && rchestDist < 0.3f)
						{
							mRHandChopTarget = 0.0f;
							mRHandStraightenTarget = 0.0f;
							mRHandFistTarget = 0.7f * uiposeadjust.val;
							rhanddebug += " OnChest";
						}
						rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
						rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
						if (rdotProduct > 0.3f)
						{
							mRHandStraightenTarget = 0.0f;
							mRHandFistTarget = 0.8f;
							mRHandChopTarget = 0.0f;
							rhanddebug += " AtBack";
						}
						
						if (rlhandDist < minHandDist)
						{
							mRHandStraightenTarget = maxStraighten;
							mRHandFistTarget = 0.0f;
							mRHandChopTarget = -1.0f;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " Hands";
						}
						if (uigenericcol.val)
						{
							if (rHandController.followWhenOffRB.SweepTest(-rHandController.followWhenOff.up, out hit, 0.1f))
							{
								hitdetected = true;
								if (rmoveDist > 0.001f)
								{
									hitDist = Mathf.Min(hit.distance, 0.08f);
								}
								//SuperController.singleton.ClearErrors();
								//SuperController.LogError("Collision " + hit.distance);
							}
							if (hitdetected || rHandCollisionTimer > 0.0f)
							{
								if (rHandCollisionTimer <= 0.0f)
								{
									rHandCollisionTimer = 0.5f;
								}
								else
								{
									rHandCollisionTimer -= Time.fixedDeltaTime;
								}
								
								mRHandStraightenTarget = maxStraighten * 0.8f * (1.0f - (hitDist * 100.0f));
								mRHandFistTarget = maxFist * 0.1f;
								mRHandChopTarget = -0.2f;
								rhanddebug += " Col";
							}
						}
						if (rfloorDist < uitoeground.val + uitoegroundclear.val)
						{
							mRHandStraightenTarget = Mathf.Lerp(maxStraighten, 0.0f, rfloorDist/(uitoeground.val + uitoegroundclear.val));
							mRHandFistTarget = 0.0f;
							mRHandChopTarget = -0.2f;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " Floor";
						}
					}
					else
					{
						rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
						rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
						if (rhipLDist < minHipDist || rhipRDist < minHipDist)
						{
							if (rdotProduct > 0.1f)
							{
								mRHandStraightenTarget = 1.0f;
								mRHandFistTarget = 0.0f;
								mRHandChopTarget = 0.2f;
								rhanddebug += " AtButt";
							}
							else
							{
								mRHandStraightenTarget = maxStraighten * 0.6f;
								mRHandFistTarget = maxFist * 0.3f;
								mRHandChopTarget = -0.2f;
								rthumbOut = 0.2f;
								rhanddebug += " AtHip";
							}
						}
						if (rabsDist < minAbsDist * 2.0f)
						{
							rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
							rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
							if (rdotProduct > 0.1f && rabsDist < minAbsDist)
							{
								mRHandStraightenTarget = 0.0f;
								mRHandFistTarget = maxFist;
								mRHandChopTarget = 0.2f;
								rhanddebug += " BehindAbs";
							}
							else
							{
								if (rdotProduct < 0.5f)
								{
								mRHandStraightenTarget = maxStraighten * 0.6f;
								mRHandFistTarget = maxFist * 0.3f;
								mRHandChopTarget = -0.2f;
								rthumbOut = 0.5f;
								rhanddebug += " SideAbs";
								}
								else
								{
									if (rabsDist < minAbsDist)
									{
										mRHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
										mRHandFistTarget = maxFist * 0.1f;
										mRHandChopTarget = 0.2f * uiposeadjust.val;
										rHandRelaxAmount = 0.5f;
										rhanddebug += " AtAbs";
									}
								}
							}
						}
						if (rthighLDist < minThighDist || rthighRDist < minThighDist)
						{
							mRHandStraightenTarget = maxStraighten * 1.5f * uiposeadjust.val;
							mRHandFistTarget = maxFist * 0.0f;
							mRHandChopTarget = 0.0f * uiposeadjust.val;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " atThigh";
						}
						if (rpelvisDist < minPelvisDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.0f;
							mLHandChopTarget = 0.8f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
							rhanddebug += " Pelvis";
						}
						if (rchestDist < minChestDist)
						{
							mRHandStraightenTarget = maxStraighten * 0.6f;
							mRHandFistTarget = maxFist * 0.3f;
							mRHandChopTarget = -0.5f;
							rhanddebug += " AtChest";
						}
						if (rnippleLDist < minNippleDist || rnippleRDist < minNippleDist)
						{
							mRHandStraightenTarget = 0.0f;
							mRHandStraightenTarget = maxStraighten * 0.8f;
							mRHandFistTarget = maxFist * 0.3f;
							mRHandChopTarget = 0.0f;
							rthumbOut = 0.20f;
							rhanddebug += " AtNipple";
						}
						rhanddir = headController.followWhenOff.position - rcurhandpos;
						rdotProduct = Vector3.Dot(rhanddir, headController.followWhenOff.forward);
						if (rheadDist < minHeadDist)
						{
							if (rdotProduct < -0.1f)
							{
								mRHandStraightenTarget = maxStraighten * 0.8f;
								mRHandFistTarget = maxFist * 0.1f;
								mRHandChopTarget = -0.7f;
								rHandRelaxAmount = 0.2f;
								rhanddebug += " AtFace";
							}
							else
							{
								if (rdotProduct > 0.07f)
								{
									mRHandStraightenTarget = maxStraighten * 0.4f;
									mRHandFistTarget = maxFist * 0.3f;
									mRHandChopTarget = -0.1f;
									rhanddebug += " BehindHead";
								}
								else
								{
									mRHandStraightenTarget = maxStraighten * 0.3f;
									mRHandFistTarget = maxFist * 0.1f;
									mRHandChopTarget = 0.3f;
									rhanddebug += " SideHead";
								}
							}
						}
					}

				morphsReset = false;
				for (int currentHand = 0; currentHand < 2; currentHand++)
				{
					matchedPose = -1;
					fingerMatches = 0.0f;
					currentMatches = 0.0f;
					lastMatch = currentMatch[currentHand];

					for(int currentPose = 0; currentPose < totalPoses; currentPose++)
					{
						currentMatches = 0.0f;
						if (fingerPoseArray[currentPose, 0, 0] > -1.0f)
						{
							for (int currentFinger = 0; currentFinger < 5; currentFinger++)
							{
								if (Mathf.Abs(fingerInputArray[currentHand,currentFinger,0] - fingerPoseArray[currentPose, currentFinger, 0]) <= accuracy)
								{
									if (Mathf.Abs(fingerInputArray[currentHand,currentFinger,1] - fingerPoseArray[currentPose, currentFinger, 1]) <= accuracy)
									{
										if (uiSkipDistal.val == false)
										{
											if (Mathf.Abs(fingerInputArray[currentHand,currentFinger,2] - fingerPoseArray[currentPose, currentFinger, 2]) <= accuracy)
											{
												currentMatches = currentMatches + 1.0f;
											}
										}
										else
										{
											currentMatches = currentMatches + 1.0f;
										}
									}
								}
							}
							if (currentMatches >= minMatches && currentMatches > fingerMatches)
							{
								matchedPose = currentPose;
								fingerMatches = currentMatches;
							}
						}
					}

					if (matchedPose > -1)
					{
						if (matchedPose != currentMatch[currentHand])
						{
							currentMatchTime[currentHand] = 0.0f;
							currentMatch[currentHand] = matchedPose;
						}
						else
						{
							currentMatchTime[currentHand] += Time.fixedDeltaTime;
							if (currentMatchTime[currentHand] >= minMatchTime)
							{
								matchedPose = currentMatch[currentHand];
							}
							else
							{
								matchedPose = lastMatch;
							}
						}
					}
					else
					{
						currentMatch[currentHand] = -1;
						currentMatchTime[currentHand] = 0.0f;
						lastMatch = -1;
						matchedPose = -1;
					}
					
					if (matchedPose > -1 && currentMatchTime[currentHand] >= minMatchTime)
					{
						//Left Hand
						if (currentHand == 0)
						{
							mLHandStraightenTarget = fingerMorphArray[matchedPose, 0];
							mLHandFistTarget = fingerMorphArray[matchedPose, 1];
							mLHandChopValue = fingerMorphArray[matchedPose, 2];
							lhandCurl = fingerMorphArray[matchedPose, 3];
							lHandRelaxAmount = fingerMorphArray[matchedPose, 4];
							lthumbOut = fingerMorphArray[matchedPose, 5];
							lhanddebug += " Overriding via Fingers";
						}
						//Right Hand
						if (currentHand == 1)
						{
							mRHandStraightenTarget = fingerMorphArray[matchedPose, 0];
							mRHandFistTarget = fingerMorphArray[matchedPose, 1];
							mRHandChopValue = fingerMorphArray[matchedPose, 2];
							rhandCurl = fingerMorphArray[matchedPose, 3];
							rHandRelaxAmount = fingerMorphArray[matchedPose, 4];
							rthumbOut = fingerMorphArray[matchedPose, 5];
							rhanddebug += " Overriding via Fingers";
						}
						
					}
				}
						
					if (mLHandStraightenTarget > mLHandStraightenValue) { mLHandStraightenValue = Mathf.Min(mLHandStraightenValue + (mLHandStraightenTarget - mLHandStraightenValue) / (15.0f / uianimationspeed.val), mLHandStraightenTarget); }
					if (mLHandStraightenTarget < mLHandStraightenValue) { mLHandStraightenValue = Mathf.Max(mLHandStraightenValue - (mLHandStraightenValue - mLHandStraightenTarget) / (15.0f / uianimationspeed.val), mLHandStraightenTarget); }
					morphLHandStraighten.morphValue = Round(mLHandStraightenValue) * uistraightenadjust.val;
					if (mRHandStraightenTarget > mRHandStraightenValue) { mRHandStraightenValue = Mathf.Min(mRHandStraightenValue + (mRHandStraightenTarget - mRHandStraightenValue) / (15.0f / uianimationspeed.val), mRHandStraightenTarget); }
					if (mRHandStraightenTarget < mRHandStraightenValue) { mRHandStraightenValue = Mathf.Max(mRHandStraightenValue - (mRHandStraightenValue - mRHandStraightenTarget) / (15.0f / uianimationspeed.val), mRHandStraightenTarget); }
					morphRHandStraighten.morphValue = Round(mRHandStraightenValue) * uistraightenadjust.val;

					if (mLHandFistTarget > mLHandFistValue) { mLHandFistValue = Mathf.Min(mLHandFistValue + (mLHandFistTarget - mLHandFistValue) / (15.0f / uianimationspeed.val), mLHandFistTarget); }
					if (mLHandFistTarget < mLHandFistValue) { mLHandFistValue = Mathf.Max(mLHandFistValue - (mLHandFistValue - mLHandFistTarget) / (15.0f / uianimationspeed.val), mLHandFistTarget); }
					morphLHandFist.morphValue = Round(mLHandFistValue) * uigraspadjust.val;
					if (mRHandFistTarget > mRHandFistValue) { mRHandFistValue = Mathf.Min(mRHandFistValue + (mRHandFistTarget - mRHandFistValue) / (15.0f / uianimationspeed.val), mRHandFistTarget); }
					if (mRHandFistTarget < mRHandFistValue) { mRHandFistValue = Mathf.Max(mRHandFistValue - (mRHandFistValue - mRHandFistTarget) / (15.0f / uianimationspeed.val), mRHandFistTarget); }
					morphRHandFist.morphValue = Round(mRHandFistValue) * uigraspadjust.val;

					if (mLHandChopTarget > mLHandChopValue) { mLHandChopValue = Mathf.Min(mLHandChopValue + (mLHandChopTarget - mLHandChopValue) / (15.0f / uianimationspeed.val), mLHandChopTarget); }
					if (mLHandChopTarget < mLHandChopValue) { mLHandChopValue = Mathf.Max(mLHandChopValue - (mLHandChopValue - mLHandChopTarget) / (15.0f / uianimationspeed.val), mLHandChopTarget); }
					morphLHandChop.morphValue = Round(mLHandChopValue) * uichopadjust.val;
					if (mRHandChopTarget > mRHandChopValue) { mRHandChopValue = Mathf.Min(mRHandChopValue + (mRHandChopTarget - mRHandChopValue) / (15.0f / uianimationspeed.val), mRHandChopTarget); }
					if (mRHandChopTarget < mRHandChopValue) { mRHandChopValue = Mathf.Max(mRHandChopValue - (mRHandChopValue - mRHandChopTarget) / (15.0f / uianimationspeed.val), mRHandChopTarget); }
					morphRHandChop.morphValue = Round(mRHandChopValue) * uichopadjust.val;

					if (lthumbOutActual < lthumbOut)
					{
						lthumbOutActual = Mathf.Clamp(lthumbOutActual + (0.01f * uianimationspeed.val), -1.0f, lthumbOut);
					}
					if (lthumbOutActual > lthumbOut)
					{
						lthumbOutActual = Mathf.Clamp(lthumbOutActual - (0.01f * uianimationspeed.val), lthumbOut, 1.0f);
					}
					
					if (rthumbOutActual < rthumbOut)
					{
						rthumbOutActual = Mathf.Clamp(rthumbOutActual + (0.01f * uianimationspeed.val), -1.0f, rthumbOut);
					}
					if (rthumbOutActual > rthumbOut)
					{
						rthumbOutActual = Mathf.Clamp(rthumbOutActual - (0.01f * uianimationspeed.val), rthumbOut, 1.0f);
					}
					
					morphLThumbGrasp.morphValue = (Round(mLHandFistValue - mLHandStraightenValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val;
					morphRThumbGrasp.morphValue = (Round(mRHandFistValue - mRHandStraightenValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val;
					morphLThumbFist.morphValue = (Round(mLHandStraightenValue + mLHandFistValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val;//Round(mLHandFistValue - (mLHandStraightenValue / 2.0f) + (Mathf.Max(-mLHandChopValue, 0.0f)), Mathf.Lerp(-0.5f, 0.0f, Round(lmoveDist*100.0f, 0.0f, 1.0f)), 1.0f);
					morphRThumbFist.morphValue = (Round(mRHandStraightenValue + mRHandFistValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val;//Round(mRHandFistValue - (mRHandStraightenValue / 2.0f) + (Mathf.Max(-mRHandChopValue, 0.0f)), Mathf.Lerp(-0.5f, 0.0f, Round(rmoveDist*100.0f, 0.0f, 1.0f)), 1.0f);
					morphLThumbInOut.morphValue = -uithumboffset.val * 3.0f;
					morphRThumbInOut.morphValue = -uithumboffset.val * 3.0f;
					
					if (lhandcurlActual < lhandCurl)
					{
						lhandcurlActual = Mathf.Clamp(lhandcurlActual + (0.01f * uianimationspeed.val), -1.0f, lhandCurl);
					}
					if (lhandcurlActual > lhandCurl)
					{
						lhandcurlActual = Mathf.Clamp(lhandcurlActual - (0.01f * uianimationspeed.val), lhandCurl, 1.0f);
					}
					
					if (lHandRelaxAmountActual < lHandRelaxAmount)
					{
						lHandRelaxAmountActual = Mathf.Clamp(lHandRelaxAmountActual + (0.01f * uianimationspeed.val), -1.0f, lHandRelaxAmount);
					}
					if (lHandRelaxAmountActual > lHandRelaxAmount)
					{
						lHandRelaxAmountActual = Mathf.Clamp(lHandRelaxAmountActual - (0.01f * uianimationspeed.val), lHandRelaxAmount, 1.0f);
					}
					
					float tempfloat;
					tempfloat = Mathf.Clamp(Round(Mathf.Clamp((1.0f - mLHandStraightenValue) * (1.0f - (lmoveDist * 33.0f)),0.0f,1.0f) * lHandRelaxAmountActual * uifingercurl.val * lhandcurlActual), -0.2f, 1.0f);
					if (lHandRelaxActual < tempfloat)
					{
						lHandRelaxActual = Mathf.Clamp(lHandRelaxActual + (0.01f * uianimationspeed.val), -1.0f, tempfloat);
					}
					if (lHandRelaxActual > tempfloat)
					{
						lHandRelaxActual = Mathf.Clamp(lHandRelaxActual - (0.01f * uianimationspeed.val), tempfloat, 1.0f);
					}
					
					morphLIndexBend.morphValue = lHandRelaxActual * 0.1f;
					morphLMiddleBend.morphValue = lHandRelaxActual * 0.3f;
					morphLRingBend.morphValue = lHandRelaxActual * 0.45f;
					morphLPinkyBend.morphValue = lHandRelaxActual * 0.7f;
					
					if (rhandcurlActual < rhandCurl)
					{
						rhandcurlActual = Mathf.Clamp(rhandcurlActual + (0.01f * uianimationspeed.val), -1.0f, rhandCurl);
					}
					if (rhandcurlActual > rhandCurl)
					{
						rhandcurlActual = Mathf.Clamp(rhandcurlActual - (0.01f * uianimationspeed.val), rhandCurl, 1.0f);
					}

					if (rHandRelaxAmountActual < rHandRelaxAmount)
					{
						rHandRelaxAmountActual = Mathf.Clamp(rHandRelaxAmountActual + (0.01f * uianimationspeed.val), -1.0f, rHandRelaxAmount);
					}
					if (rHandRelaxAmountActual > rHandRelaxAmount)
					{
						rHandRelaxAmountActual = Mathf.Clamp(rHandRelaxAmountActual - (0.01f * uianimationspeed.val), rHandRelaxAmount, 1.0f);
					}
					
					tempfloat = Mathf.Clamp(Round(Mathf.Clamp((1.0f - mRHandStraightenValue) * (1.0f - (rmoveDist * 33.0f)),0.0f,1.0f) * rHandRelaxAmountActual * uifingercurl.val * rhandcurlActual), -0.2f, 1.0f);
					if (rHandRelaxActual < tempfloat)
					{
						rHandRelaxActual = Mathf.Clamp(rHandRelaxActual + (0.01f * uianimationspeed.val), -1.0f, tempfloat);
					}
					if (rHandRelaxActual > tempfloat)
					{
						rHandRelaxActual = Mathf.Clamp(rHandRelaxActual - (0.01f * uianimationspeed.val), tempfloat, 1.0f);
					}
					
					morphRIndexBend.morphValue = rHandRelaxActual * 0.1f;
					morphRMiddleBend.morphValue = rHandRelaxActual * 0.3f;
					morphRRingBend.morphValue = rHandRelaxActual * 0.45f;
					morphRPinkyBend.morphValue = rHandRelaxActual * 0.7f;
					
					if (lhanddebug != lhanddebugold)
					{
						poseSwitchCountL = Mathf.Min(poseSwitchCountL + 1, 5.0f);
					}
					else
					{
						poseSwitchCountL = Mathf.Max(poseSwitchCountL - 0.1f, 0.0f);
					}
					if (rhanddebug != rhanddebugold)
					{
						poseSwitchCountR = Mathf.Min(poseSwitchCountR + 1, 5.0f);
					}
					else
					{
						poseSwitchCountR = Mathf.Max(poseSwitchCountR - 0.1f, 0.0f);
					}

					morphBufferL = 0.05f * poseSwitchCountL;
					morphBufferR = 0.05f * poseSwitchCountR;
					lhanddebugold = lhanddebug;
					rhanddebugold = rhanddebug;
					
					if (uiShowStats.val)
					{
						SuperController.singleton.ClearMessages();
						SuperController.LogMessage(lhanddebug, false);
						SuperController.LogMessage(rhanddebug, false);
						SuperController.LogMessage("Left Grasp " + Round(mLHandFistValue), false);		
						SuperController.LogMessage("Right Grasp " + Round(mRHandFistValue), false);		
						SuperController.LogMessage("Left Straighten " + Round(mLHandStraightenValue), false);		
						SuperController.LogMessage("Right Straighten " + Round(mRHandStraightenValue), false);

						SuperController.LogMessage("Left Thumb Grasp " + Round((Round(mLHandFistValue - mLHandStraightenValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val), false);		
						SuperController.LogMessage("Right Thumb Grasp " + Round((Round(mRHandFistValue - mRHandStraightenValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val), false);
						SuperController.LogMessage("Left Thumb Fist " + Round((Round(mLHandStraightenValue + mLHandFistValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val), false);		
						SuperController.LogMessage("Right Thumb Fist " + Round((Round(mRHandStraightenValue + mRHandFistValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val), false);
						SuperController.LogMessage("ui Thumb Offset " + uithumboffset.val, false);		
						SuperController.LogMessage("ui Thumb Adjust " + uithumbadjust.val, false);

						SuperController.LogMessage("Left Thumb Out " + Round(lthumbOutActual), false);
						SuperController.LogMessage("Right Thumb Out " + Round(rthumbOutActual), false);						
						SuperController.LogMessage("Left Chop " + Round(mLHandChopValue), false);		
						SuperController.LogMessage("Right Chop " + Round(mRHandChopValue), false);		
						SuperController.LogMessage("Left Relax " + Round(lHandRelaxActual), false);		
						SuperController.LogMessage("Right Relax " + Round(rHandRelaxActual), false);		
						SuperController.LogMessage("Left Relax Amount " + Round(lHandRelaxAmount), false);		
						SuperController.LogMessage("Right Relax Amount " + Round(rHandRelaxAmount), false);		
						SuperController.LogMessage("Left Curl " + Round(lhandcurlActual), false);		
						SuperController.LogMessage("Right Curl " + Round(rhandcurlActual), false);		
						SuperController.LogMessage("lhipLDist " + Round(lhipLDist), false);
						SuperController.LogMessage("lhipRDist " + Round(lhipRDist), false);
						SuperController.LogMessage("lthighLDist " + Round(lthighLDist), false);
						SuperController.LogMessage("lthighRDist " + Round(lthighRDist), false);
						SuperController.LogMessage("lpelvisDist " + Round(lpelvisDist), false);
						SuperController.LogMessage("lchestDist " + Round(lchestDist), false);
						SuperController.LogMessage("lnippleLDist " + Round(lnippleLDist), false);
						SuperController.LogMessage("lnippleRDist " + Round(lnippleRDist), false);
						SuperController.LogMessage("labsDist " + Round(labsDist), false);
						SuperController.LogMessage("lheadDist " + Round(lheadDist), false);
						SuperController.LogMessage("lrhandDist " + Round(lrhandDist), false);
						SuperController.LogMessage("lmoveDist " + Round(lmoveDist), false);
						SuperController.LogMessage("", false);
						SuperController.LogMessage("rhipLDist " + Round(rhipLDist), false);
						SuperController.LogMessage("rhipRDist " + Round(rhipRDist), false);
						SuperController.LogMessage("rthighLDist " + Round(rthighLDist), false);
						SuperController.LogMessage("rthighRDist " + Round(rthighRDist), false);
						SuperController.LogMessage("rpelvisDist " + Round(rpelvisDist), false);
						SuperController.LogMessage("rchestDist " + Round(rchestDist), false);
						SuperController.LogMessage("rnippleLDist " + Round(rnippleLDist), false);
						SuperController.LogMessage("rnippleRDist " + Round(rnippleRDist), false);
						SuperController.LogMessage("rabsDist " + Round(rabsDist), false);
						SuperController.LogMessage("rheadDist " + Round(rheadDist), false);
						SuperController.LogMessage("rlhandDist " + Round(rlhandDist), false);
						SuperController.LogMessage("rmoveDist " + Round(rmoveDist), false);		
            
					}

				}
				
				
				lhandpos = lcurhandpos;
				rhandpos = rcurhandpos;
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// OnDestroy is where you should put any cleanup
		// if you registered objects to supercontroller or atom, you should unregister them here
		void OnDestroy() {
			SuperController.singleton.ClearMessages();
					//	SuperController.LogMessage("Exiting!");
					//	jsp.CallAction("LoadPreset");

		}
		
		public static float Round(float value)
		{
			return Mathf.Round(value * 100.0f) / 100.0f;
		}
	}
}